﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.Samples.ServiceHosting.StorageClient;
using Microsoft.Samples.PersonalWebSite_WebRole.Code.Article;

namespace Microsoft.Samples.PersonalWebSite_WebRole.Admin
{
    public partial class AddOrEdit : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Request.QueryString.Count == 0)
            {
                if (!IsPostBack)
                {
                    txtPubDate.Text = DateTime.Now.ToString();
                }
            }
            else
            {
                if (!IsPostBack)
                {
                    string rowKey = Request.QueryString[0];

                    hdValue.Value = rowKey;

                    StorageAccountInfo accountInfo = StorageAccountInfo.GetAccountInfoFromConfiguration("TableStorageEndpoint");
                    TableStorage.CreateTablesFromModel(typeof(ArticleDataServiceContext), accountInfo);
                    ArticleDataServiceContext context = new ArticleDataServiceContext(accountInfo);

                    Article c = new Article();
                    c = context.Articles.Where(p => p.RowKey == rowKey).FirstOrDefault();

                    try
                    {

                        txtTitle.Text = c.Title;
                        txtContext.Content = c.Content;
                        txtPubDate.Text = c.PubDate.ToString();
  
                    }
                    catch (Exception ex)
                    {
                        Response.Write(ex.Message);
                    }
                }

            }

        }

        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            try
            {
                Article a = new Article();
                a.PubDate = DateTime.Parse(txtPubDate.Text);
                a.Content = txtContext.Content;
                a.Title = txtTitle.Text;

                StorageAccountInfo accountInfo = StorageAccountInfo.GetAccountInfoFromConfiguration("TableStorageEndpoint");
                TableStorage.CreateTablesFromModel(typeof(ArticleDataServiceContext), accountInfo);
                ArticleDataServiceContext context = new ArticleDataServiceContext(accountInfo);

                if (string.IsNullOrEmpty(hdValue.Value))
                {
                    context.AddArticle(a);
                }
                else
                {
                    a.RowKey = hdValue.Value;
                    context.UpdateArticle(a);
                }

                Response.Redirect("ManageArticles.aspx");
            }
            catch (Exception ex)
            {
                Response.Write(ex.Message);

            }
        }
    }
}
